/************************Copyright (c)*******************************************************************
*********************************************************************************************************
**                 合肥途思电子科技有限公司            
**                        研发中心                             
**                         硬件部                                
**                                                               
**                http://www.tinysine.com                                 
**
**-------------文件信息---------------------------------------------------------------------------------
****文   件   名：Call

****版        本：V1r1
****日        期：2020年2月21日
****程   序   员：HuangChao
****描        述：for 4G Shield V1r1
         
****版        本：V1r0
****日        期：2020年2月4日
****程   序   员：HuangChao
****描        述： 
****备        注: 
                1.Please use Arduino 1.0.1 version
                2.Please select the Mega2560 board or UNO
**              
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

/********************************************************************************************************
 * 										INCLUDE FILES
********************************************************************************************************/
#include <SoftwareSerial.h>


/********************************************************************************************************
 *CONSTANTS
********************************************************************************************************/
#define CR                   0x0D                    // carriage return
#define LF                   0x0A                    // line feed

#define SUB                  0x1A                    // substitute ctrl-Z

#define GREATER_THAN_SIGN    0x3E                    // >
#define SPACE                0x20


/********************************************************************************************************
 * 										VARIABLES DEFINITION
********************************************************************************************************/
HardwareSerial &SerialDebug=Serial;

SoftwareSerial SerialSim7600(2, 3);                 //for Uno,the software serial port rx pin is D2, tx pin is D3
//HardwareSerial &SerialSim7600=Serial2;            //for Mega2560,the hardware serial port is the serial2

boolean SIM7600ReadyFlag=false;
char StringOK[]="OK";
char StringNOCARRIER[]="NO CARRIER";
char StringRING[]="RING";


/********************************************************************************************************
 * 										FUNCTION PROTOTYPES
********************************************************************************************************/

/*********************************************************************************************************
** 函数名称: void setup()
** 功能描述: 
** 输　  入: void 
** 输　  出: void      
**-------------------------------------------------------------------------------------------------------
** 说    明:	
** 日　  期:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void setup()
{
  unsigned char i=0;
  
  SerialDebug.begin(9600);  
  
  SerialSim7600.begin(9600); 
  SerialSim7600.setTimeout(1000);  //1s
  
  for(i=0;i<3;i++)
  {
    SerialDebug.print(F("Try AT test "));
    SerialDebug.println(i);
    
    if(true==ATTest())
    {
      SIM7600ReadyFlag=true;
      break;  
    }
    delay(1000);
    SerialSim7600FlushRxBuf();
  }
}

/*********************************************************************************************************
** 函数名称: void loop()
** 功能描述: 
** 输　  入: void 
** 输　  出: void      
**-------------------------------------------------------------------------------------------------------
** 说    明:	
** 日　  期:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void loop()
{
  if(true==SIM7600ReadyFlag)
  {
    MakeACall();
  }
}

/*********************************************************************************************************
** 函数名称: void MakeACall(void)
** 功能描述: 
** 输　  入: void 
** 输　  出: void      
**-------------------------------------------------------------------------------------------------------
** 说    明:	
** 日　  期:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void MakeACall(void)
{   
  char keypad_value; 
  boolean no_carrier_flag=false;
  boolean ring_flag=false;
  
  while(1)
  {
    delay(1000);                   //1s
    SerialDebugFlushRxBuf();
    SerialSim7600FlushRxBuf();
    
    SerialDebug.println();
    SerialDebug.println(F("****************************************"));
    SerialDebug.println(F("*************** Call *******************"));
    SerialDebug.println(F("Give 13965130794 a call,Please type 1"));
    SerialDebug.println(F("Waiting a call,         Please type 2"));
  
    while(!SerialDebug.available());  //waitting input number
  
    keypad_value=SerialDebug.read();
    if('1'==keypad_value)
    {
      SerialDebug.println(F("Dialing ..."));
      
      SerialSim7600.print(F("ATD13965130794;"));                     //Change the numbers to your numbers
      SerialSim7600.write(CR);    
      SerialSim7600.flush();
      SerialSim7600.find(StringOK); 

      while(1)
      {
        SerialSim7600.setTimeout(100000);  //100s
        no_carrier_flag=SerialSim7600.find(StringNOCARRIER); 
        SerialSim7600.setTimeout(1000);   //1s
        if(true==no_carrier_flag)
        {
          SerialDebug.println(F("Call end"));
          break;
        }
      }
    }
    else if('2'==keypad_value)
    {
      SerialDebug.println(F("Please call me ..."));
      while(!SerialSim7600.available());
      ring_flag=SerialSim7600.find(StringRING); 
      
      if(true==ring_flag)
      {
        SerialDebugFlushRxBuf();
        
        SerialDebug.println(F("Ring ..."));
        SerialDebug.println(F("Answer, Please type 1"));
        SerialDebug.println(F("Hang up,Please type 2"));
        
        while(!SerialDebug.available());
        keypad_value=SerialDebug.read();
        if(('1'==keypad_value))
        {
          SerialDebug.println(F("Answer"));
          SerialSim7600.print(F("ATA"));
          SerialSim7600.write(CR);    
          SerialSim7600.flush(); 
          SerialSim7600.find(StringOK);
          
          SerialSim7600.setTimeout(100000);  //100s
          no_carrier_flag=SerialSim7600.find(StringNOCARRIER); 
          SerialSim7600.setTimeout(1000);   //1s
        }
        else if(('2'==keypad_value))
        {
          SerialDebug.println(F("Hang up"));
          
          SerialSim7600.print(F("AT+CVHU=0"));
          SerialSim7600.write(CR);    
          SerialSim7600.flush(); 
          SerialSim7600.find(StringOK);
          
          SerialSim7600.print(F("ATH"));
          SerialSim7600.write(CR);    
          SerialSim7600.flush(); 
          SerialSim7600.find(StringOK);
        } 
      }
    }
  }
}

/*********************************************************************************************************
** 函数名称: void SerialSim7600FlushRxBuf(void)
** 功能描述: 
** 输　  入: void 
** 输　  出: void      
**-------------------------------------------------------------------------------------------------------
** 说    明:	
** 日　  期:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void SerialSim7600FlushRxBuf(void)
{
  while(SerialSim7600.available())
  {
    SerialSim7600.read();
  }
}

/*********************************************************************************************************
** 函数名称: void SerialDebugFlushRxBuf(void)
** 功能描述: 
** 输　  入: void 
** 输　  出: void      
**-------------------------------------------------------------------------------------------------------
** 说    明:	
** 日　  期:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void SerialDebugFlushRxBuf(void)
{
  while(SerialDebug.available())
  {
    SerialDebug.read();
  }
}

/*********************************************************************************************************
** 函数名称: boolean ATTest(void)
** 功能描述: 
** 输　  入: void 
** 输　  出: boolean      
**-------------------------------------------------------------------------------------------------------
** 说    明:	
** 日　  期:
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
boolean ATTest(void)
{
  boolean at_test_result=false;
  
  SerialSim7600.print(F("AT"));
  SerialSim7600.write(CR); 
  SerialSim7600.flush();                          //Waits for the transmission of outgoing serial data to complete
  
  at_test_result=SerialSim7600.find(StringOK);    
  
  if(true==at_test_result)
  {
    SerialDebug.println(F("ATtest OK"));
  }
  else
  {
    SerialDebug.println(F("ATtest Fail"));
  }
  return(at_test_result);
}
  
/********************************************************************************************************
**                            End Of File
********************************************************************************************************/ 




